//
//  MAdvertiseLocation.swift
//  MAdvertiseLocation
//
//  Created by htrimech MacBook Pro on 08/10/2018.
//  Copyright © 2018 MAdvertise. All rights reserved.
//

import UIKit
@objc
public class MAdvertiseLocation: NSObject {
    
    @objc
    static var appId:String? = nil
    @objc
    var launchOptions : [UIApplication.LaunchOptionsKey: Any]? = nil
    @objc
    static var modeDebugIsEnabled:Bool = false
    @objc
    static let madvertiseLocationManagerShared : MadvertiseLocationManager = MadvertiseLocationManager.shared
    
    @objc
    init(madvertiseBuilder:MadvertiseBuilder) {
        MAdvertiseLocation.appId = madvertiseBuilder.appId
        launchOptions = madvertiseBuilder.launchOptions
    }
    /**
     Start the location service. Mandatory to collect user locations.
     */
    @objc
    public class func start(madvertiseLocation:MAdvertiseLocation){
        if MAdvertiseLocation.appId == nil{
            MadvertiseLocationUtility.logErrorMessage("App ID is null")
            return
        }
        madvertiseLocationManagerShared.start(madvertiseLocation: madvertiseLocation)

    }
    /**
     Request the location authorization to the user if needed.
     */
    @objc
    public class func madvertiseLocationRequestAuthorization() {
        if MAdvertiseLocation.appId == nil{
            MadvertiseLocationUtility.logErrorMessage("App ID is null")
            return
        }
          MadvertiseLocationUtility.logErrorMessage("madvertiseLocationRequestAuthorization")
          madvertiseLocationManagerShared.madvertiseLocationRequestAuthorization()
    }
    @objc
    public class func stop() {
        MadvertiseLocationUtility.logErrorMessage("stop madvertiseLocation")
        madvertiseLocationManagerShared.stopMadvertiseLocations()
    }
    
    /**
     Enable the debug mode for the MadvertiseLocation SDK. This mode change some SDK paramters,
     for exemple the configuration is fetch more frequently, dialogs are displayed at
     each application start, etc...
     This mode should not be used in a production environement. Be careful when enable it.
     */
    @objc
    public class func debugMode(enabled:Bool)  {
        modeDebugIsEnabled = enabled
    }
    /**
     get version  to the user if needed.
     */
    @objc
    public class  func getVersion() -> String {
        return LocationConstants.LocationSDKInfos.VERSION
    }
    /**
     get version  to the user if needed.
     */
    @objc
    public class  func getAppID() -> String {
        if MAdvertiseLocation.appId == nil  {
            MadvertiseLocationUtility.logErrorMessage("App ID is null")
            return ""
        }

        return  MAdvertiseLocation.appId!
    }
  
}
